Index: orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.cc	(revision 3746)
@@ -25,6 +25,11 @@
 
 #include "orxonox_gui_exec.h"
+
 #include <iostream>
 #include <string>
+
+#include <sys/stat.h>
+#include <sys/types.h>
+
 
 HashTable* orxonoxFlagHash;
@@ -50,5 +55,5 @@
   this->saveSettings->saveability();
   this->execBox->fill(this->saveSettings);
-  this->verboseMode = new Menu("verbose mode", "no output", "error", "warning", "info", "lastItem");
+  this->verboseMode = new Menu("verbose mode", "nothing", "error", "warning", "info", "lastItem");
   this->verboseMode->setFlagName("verbose", "v", 0);
   this->verboseMode->saveability();
@@ -90,6 +95,61 @@
 
 /**
+   \brief sets the confDir and File-name out of an input-string
+*/
+void OrxonoxGuiExec::setConfFile(char* confFile)
+{
+  char splitter = 
+#ifdef __WIN32__ 
+    '\\';
+#else
+  '/';
+#endif
+  char* tmpConfFile = new char[strlen(confFile)+1];
+  strcpy(tmpConfFile, confFile);
+  char* tmp = strrchr(tmpConfFile, splitter);
+  if (tmp)
+    {
+      tmp[0] = '\0';
+      this->setConfDir(tmpConfFile);
+      this->setFileName(tmp+1);
+    }
+  else
+    {
+      this->setConfDir("~/");
+      this->setFileName(tmpConfFile);
+    }
+  delete []tmp;
+  delete []tmpConfFile;
+}
+
+/**
+   \brief sets the Directory of the configuration files
+   \param confDir the Directory for the configuration files
+*/
+void OrxonoxGuiExec::setConfDir(char* confDir)
+{
+  if (!strncmp(confDir, "~/", 2))
+    {
+      char tmp[500];
+#ifdef __WIN32__
+      strcpy(tmp, getenv("USERPROFILE"));
+#else
+      strcpy(tmp, getenv("HOME"));
+#endif
+      this->confDir = new char[strlen(tmp)+strlen(confDir)];
+      sprintf(this->confDir, "%s%s", tmp, confDir+1);
+    }
+  else
+    {
+      this->confDir = new char[strlen(confDir)+1];
+      strcpy(this->confDir, confDir);
+    }
+  PRINTF(3)("Config Directory is: %s.\n", this->confDir);
+  mkdir(this->confDir, 0755);
+}
+
+/**
    \brief Sets the location of the configuration File.
-   \param filename the location of the configFile
+   \param fileName the location of the configFile
 
    \todo: memory allocation could be better.
@@ -97,19 +157,11 @@
    The name will be parsed from ~/ to /home/[username] on unix and c:/Documents and Settings/username/Settings/ on Windows
 */
-void OrxonoxGuiExec::setFilename(char* filename)
-{
-  char* buffer = (char*)malloc(2048*sizeof(char));
-  sprintf(buffer, "%s", filename);
-  if(!strncmp(buffer, "~/", 2))
-  {
-#ifdef __WIN32__
-    sprintf(configFile, "%s/%s", getenv("USERPROFILE"), buffer+2);
-#else
-    sprintf(configFile, "%s/%s", getenv("HOME"), buffer+2);
-#endif
-  }
-  else if(buffer)
-    strcpy(this->configFile, buffer);
-  free (buffer);
+void OrxonoxGuiExec::setFileName(char* fileName)
+{
+  if (!this->confDir)
+    this->setConfDir("~/");
+  this->configFile = new char[strlen(this->confDir)+strlen(fileName)+2];
+  sprintf(this->configFile, "%s/%s", this->confDir, fileName);
+  PRINTF(3)("ConfigurationFile is %s.\n", this->configFile);
 }
 
@@ -117,5 +169,5 @@
    \returns The name of the Configuration-File
 */
-char* OrxonoxGuiExec::getConfigFile(void)
+char* OrxonoxGuiExec::getConfigFile(void) const
 {
   return this->configFile;
@@ -190,8 +242,5 @@
 	    space2under[0] = '_';
 	  }
-	if(widget->isOption <=3)
-	  fprintf(CONFIG_FILE, "%s = %d\n", Buffer, static_cast<Option*>(widget)->value);
-	else if(widget->isOption == 5)
-	  fprintf(CONFIG_FILE, "%s = %s\n", Buffer, static_cast<OptionLabel*>(widget)->cValue);
+	  fprintf(CONFIG_FILE, "%s = %s\n", Buffer, static_cast<Option*>(widget)->save());
       }
 
@@ -259,11 +308,6 @@
     {
       PRINT(3)("Located Option %s.\n", widget->title);
-      if(widget->isOption >= 1 && widget->isOption <= 3)
-	{
-	  static_cast<Option*>(widget)->value = atoi(info->variableValue);
-	  static_cast<Option*>(widget)->redraw(); //!< \todo change this to setValue.
-	}
-      else if(widget->isOption == 5)
-	static_cast<OptionLabel*>(widget)->setValue(info->variableValue);
+      if(widget->isOption >= 1)
+	  static_cast<Option*>(widget)->load(info->variableValue);
     }
 }
Index: orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.h
===================================================================
--- orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_exec.h	(revision 3746)
@@ -22,4 +22,5 @@
   CheckButton* alwaysShow;     //!< A CheckButton, for if orxonox should start with or without gui.
   Button* quit;                //!< A Button to quit the Gui without starting orxonox.
+  char* confDir;               //!< The directory of the orxonox-configuration-files.
   char* configFile;            //!< The name of the .orxonox.conf(ig)-file.
   FILE* CONFIG_FILE;           //!< Filehandler for reading and writing.
@@ -37,7 +38,9 @@
   
   Widget* getWidget(void);
-  
-  void setFilename(char* filename);
-  char* getConfigFile(void);
+
+  void setConfFile(char* confFile);
+  void setConfDir(char* confDir);
+  void setFileName(char* fileName);
+  char* getConfigFile(void) const;
   int shouldsave(void);
   void writeToFile(Widget* widget);
Index: orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_gtk.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_gtk.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/gui/gui/orxonox_gui_gtk.cc	(revision 3746)
@@ -25,7 +25,8 @@
 
 
+#include "orxonox_gui_gtk.h"
+
+#include <stdarg.h>
 #include <iostream>
-
-#include "orxonox_gui_gtk.h"
 
 
@@ -68,8 +69,12 @@
 #else /* HAVE_GTK2 */
   char boolAns = 'y';
-  char ans[10]; 
+  char ans[10];
+  PRINT(0)("================================\n");
+  PRINT(0)("= ORXONOX CONFIGURATION WIZARD =\n");
+  PRINT(0)("================================    - version:" PACKAGE_VERSION "\n");
+
   while(true)
     {
-      PRINT(0)(" Listing all the Orxonox Options: \n");
+      PRINT(0)("\n Listing all the Orxonox Options: \n");
       PRINT(0)("  #############################\n");
       Window::mainWindow->walkThrough(Widget::listOptionsAndGroups, 1);
@@ -122,4 +127,5 @@
       //! \todo move this into the gui-gtk-file
       //! \todo finish it.
+      //! \todo memory leek at save(); and save is a BAD word, use saveString instead, or something like it.
     }
 #endif /* HAVE_GTK2 */
@@ -133,19 +139,8 @@
 
 /* WIDGET */
-
-/**
-   \brief deletes any given Widget
-   This is still pretty crappy.
-*/
-Widget::~Widget(void)
-{
-  this->destroy();
-}
-
-/**
-   \brief Initializes a widget.
-   Initializes the next Pointer and the other Widget-specific Defaults.
-*/
-void Widget::init(void)
+/**
+   \brief constructs a Widget
+*/
+Widget::Widget(void)
 {
   next = NULL;
@@ -155,9 +150,10 @@
 
 /**
-   \brief Destroys a Widget 
-*/
-void Widget::destroy(void)
-{
-  if (this->title)
+   \brief deletes any given Widget
+   This is still pretty crappy.
+*/
+Widget::~Widget(void)
+{
+    if (this->title)
     {
       delete []this->title;
@@ -172,8 +168,19 @@
     delete this->next;
   this->next = NULL;
-
   //!  \todo not hiding widget, deleting.
   //  this->hide();
   //  delete this->widget;
+}
+
+/**
+   \brief sets a new Title to a Widget
+   \param title The new Title to set to the Widget
+*/
+void Widget::setTitle(const char* title)
+{
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -273,9 +280,9 @@
 {
   if (widget->isOption < 0 && static_cast<Packer*>(widget)->groupName)
-    cout << "[" << static_cast<Packer*>(widget)->groupName << "]\n";
-  if (widget->isOption >= 1 && widget->isOption <= 3)
-    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
-  else if (widget->isOption == 5)
-    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+    PRINT(0)("[%s]\n", static_cast<Packer*>(widget)->groupName);
+  if (widget->isOption >= 1)
+    {
+      Widget::listOptions(widget);
+    }
 }
 
@@ -286,8 +293,6 @@
 void Widget::listOptions(Widget* widget)
 {
-  if (widget->isOption >= 1 && widget->isOption <= 3)
-    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
-  else if (widget->isOption == 5)
-    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+  if(widget->isOption >= 1)
+    PRINT(0)("  %s is %s\n", static_cast<Option*>(widget)->title, static_cast<Option*>(widget)->save());
 }
 
@@ -300,15 +305,9 @@
 {
   
-  if (widget->isOption >= 1 && widget->isOption <= 3)
+  if (widget->isOption >= 1)
     {
       int* count =(int*)data;
       *count = *count +1;
-      cout << *count << ": " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
-    }
-  else if (widget->isOption == 5)
-    {
-      int* count =(int*)data;
-      *count = *count +1;
-      cout << *count << ": " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+      PRINT(0)(" %d:%s is %s\n", *count, static_cast<Option*>(widget)->title, static_cast<Option*>(widget)->save());
     }
 }
@@ -513,18 +512,11 @@
 
 /* PACKERS */
-
-/**
-   \brief Initializes a Packer.
-
-   Sets the down-pinter to NULL and other PackerSpecific-values to their defaults.
-*/
-void Packer::init(void)
+/**
+   \brief Constructs a Packer
+*/
+Packer::Packer(void)
 {
   this->down = NULL;
   this->groupName = NULL;
-
-
-  static_cast<Widget*>(this)->init();
-  return;
 }
 
@@ -532,5 +524,5 @@
    \brief Destroys a Packer.
 */
-void Packer::destroy(void)
+Packer::~Packer(void)
 { 
   PRINTF(4)("deleting the Packer part.\n");
@@ -543,6 +535,4 @@
     delete this->down;
   this->down = NULL;
-
-  static_cast<Widget*>(this)->destroy();
 }
 
@@ -575,11 +565,7 @@
    sets the Container-Specific defaults.
 */
-void Container::init(void)
+Container::Container(void)
 {
   this->isOption = -1;
-
-  static_cast<Packer*>(this)->init();
-
-  return;
 }
 
@@ -587,9 +573,7 @@
    \brief Destroys a Container.
 */
-void Container::destroy(void)
+Container::~Container(void)
 { 
   PRINTF(4)("deleting the Container part.\n");
-
-  static_cast<Packer*>(this)->destroy();
 }
 
@@ -665,5 +649,9 @@
 Window::~Window(void)
 {
-  this->destroy();
+  if (this->title)
+    PRINTF(3)("deleting the Window: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the Window.\n");
+  //  this->hide();
 }
 
@@ -677,6 +665,4 @@
   
   isOpen = false;
-
-  static_cast<Container*>(this)->init();
 
 #ifdef HAVE_GTK2
@@ -691,18 +677,4 @@
 
 /**
-   \brief Destroys a Window.
-*/
-void Window::destroy(void)
-{ 
-  if (this->title)
-    PRINTF(3)("deleting the Window: %s\n", this->title);
-  else 
-    PRINTF(3)("deleting the Window.\n");
-  //  this->hide();
-  static_cast<Container*>(this)->destroy();
-  
-}
-
-/**
    \brief Shows all Widgets that are included within this->widget.
 */
@@ -730,5 +702,5 @@
    \param title title the Window should get.
 */
-void Window::setTitle(char* title)
+void Window::setTitle(const char* title)
 {
   if (this->title)
@@ -823,31 +795,19 @@
 Frame::~Frame(void)
 {
-  this->destroy();
-}
-
-/** 
-    \brief Initializes a new Frame with default settings
-*/
-void Frame::init(void)
-{
-  static_cast<Container*>(this)->init();
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_frame_new("");
-  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a Frame.
-*/
-void Frame::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Frame: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Frame.\n");
-
-   static_cast<Container*>(this)->destroy();
+}
+
+/** 
+    \brief Initializes a new Frame with default settings
+*/
+void Frame::init(void)
+{
+#ifdef HAVE_GTK2
+  this->widget = gtk_frame_new("");
+  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
+#endif /* HAVE_GTK2 */
 }
 
@@ -856,5 +816,5 @@
    \param title The title the Frame should get.
 */
-void Frame::setTitle(char* title)
+void Frame::setTitle(const char* title)
 {
   if (this->title)
@@ -892,46 +852,21 @@
 EventBox::~EventBox(void)
 {
-  this->destroy();
-
-}
-
-/**
-   \brief Initializes a new EventBox
-*/
-void EventBox::init(void)
-{
-  this->isOption = -1;
-
-  static_cast<Container*>(this)->init();
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_event_box_new();
-  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys an EventBox.
-*/
-void EventBox::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the EventBox: %s\n", this->title);
   else 
     PRINTF(3)("deleting the EventBox.\n");
-
-  static_cast<Container*>(this)->destroy();
-}
-
-/**
-   \brief Sets the Title of the EventBox(not implemented)
-   \param title Name the EventBox should get(only datastructure-internal).
-*/
-void EventBox::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char[strlen(title)+1];
-  strcpy(this->title, title);
+}
+
+/**
+   \brief Initializes a new EventBox
+*/
+void EventBox::init(void)
+{
+  this->isOption = -1;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_event_box_new();
+  gtk_container_set_border_width(GTK_CONTAINER(this->widget), 3);
+#endif /* HAVE_GTK2 */
 }
 
@@ -960,33 +895,4 @@
 Box::~Box(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initializes a new Box with type boxtype
-   \param boxtype see Box(char boxtype)
-*/
-void Box::init(char boxtype)
-{
-  this->isOption = -2;
-
-  static_cast<Packer*>(this)->init();
-#ifdef HAVE_GTK2
-  if (boxtype == 'v')
-    {
-      this->widget = gtk_vbox_new(FALSE, 0);
-    }
-  else
-    {
-      this->widget = gtk_hbox_new(FALSE, 0);
-    }
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a Box.
-*/
-void Box::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Box: %s\n", this->title);
@@ -994,5 +900,24 @@
     PRINTF(3)("deleting the Box.\n");
 
-  static_cast<Packer*>(this)->destroy();
+}
+
+/**
+   \brief Initializes a new Box with type boxtype
+   \param boxtype see Box(char boxtype)
+*/
+void Box::init(char boxtype)
+{
+  this->isOption = -2;
+
+#ifdef HAVE_GTK2
+  if (boxtype == 'v')
+    {
+      this->widget = gtk_vbox_new(FALSE, 0);
+    }
+  else
+    {
+      this->widget = gtk_hbox_new(FALSE, 0);
+    }
+#endif /* HAVE_GTK2 */
 }
 
@@ -1022,16 +947,4 @@
 }
 
-/**
-   \brief Sets the Title of a Box.
-   \param title the new Title to set.
-*/
-void Box::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char[strlen(title)+1];
-  strcpy(this->title, title);
-}
-
 /* OPTION */
 
@@ -1040,5 +953,5 @@
    sets all Option-Specific-Values to their defaults.
 */
-void Option::init(void)
+Option::Option(void)
 {
   this->value = 0;
@@ -1047,8 +960,4 @@
   this->saveable = false;
   this->defaultValue = 0;
-
-  static_cast<Widget*>(this)->init();
-
-  return;
 }
 
@@ -1056,5 +965,5 @@
    \brief Destroys an Option.
 */
-void Option::destroy(void)
+Option::~Option(void)
 { 
   PRINTF(4)("deleting the Option Part.\n");
@@ -1063,6 +972,4 @@
   if (this->flagNameShort)
     delete []this->flagNameShort;
-
-  static_cast<Widget*>(this)->destroy();
 }
 
@@ -1123,4 +1030,28 @@
 
 /**
+   \brief saves an Option
+   \returns the String that should be saved.
+
+   this is a default Option save
+*/
+char* Option::save(void)
+{
+  char* value = new char [10];
+  sprintf (value, "%d", this->value);
+  return value;
+}
+
+/**
+   \brief loads an Option from of its loadString
+   \param loadString the string from which to load the data from
+*/
+void Option::load(char* loadString)
+{
+  this->value = atoi(loadString);
+  PRINT(3)("Loading %s: %s %d\n", this->title, loadString, value); 
+  this->redraw();
+}
+
+/**
    \returns The saveable-state.
 */
@@ -1161,26 +1092,4 @@
 Button::~Button(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initializes a new Button
-*/
-void Button::init(void)
-{
-  isOption = 0;
-
-  static_cast<Option*>(this)->init();
-
-#ifdef HAVE_GTK2
-  widget = gtk_button_new_with_label("");
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a Button.
-*/
-void Button::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Label: %s\n", this->title);
@@ -1188,5 +1097,16 @@
     PRINTF(3)("deleting the Label.\n");
 
-  static_cast<Option*>(this)->destroy();
+}
+
+/**
+   \brief Initializes a new Button
+*/
+void Button::init(void)
+{
+  isOption = 0;
+
+#ifdef HAVE_GTK2
+  widget = gtk_button_new_with_label("");
+#endif /* HAVE_GTK2 */
 }
 
@@ -1195,5 +1115,5 @@
    \param title The name the Button should get
 */
-void Button::setTitle(char *title)
+void Button::setTitle(const char *title)
 {
   if (this->title)
@@ -1245,32 +1165,20 @@
 CheckButton::~CheckButton(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initialize a new CheckButton with default settings
-*/
-void CheckButton::init(void)
-{
-  this->isOption = 1;
-
-  static_cast<Option*>(this)->init();
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_check_button_new_with_label("");
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a CheckButton.
-*/
-void CheckButton::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the CheckButton: %s\n", this->title);
   else 
     PRINTF(3)("deleting the CheckButton.\n");
-
-  static_cast<Option*>(this)->destroy();
+}
+
+/**
+   \brief Initialize a new CheckButton with default settings
+*/
+void CheckButton::init(void)
+{
+  this->isOption = 1;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_check_button_new_with_label("");
+#endif /* HAVE_GTK2 */
 }
 
@@ -1279,5 +1187,5 @@
    \param title The new Name the CheckButton should display.
 */
-void CheckButton::setTitle(char* title)
+void CheckButton::setTitle(const char* title)
 {
   if (this->title)
@@ -1306,5 +1214,5 @@
 #else /* HAVE_GTK2 */
   char tmpChar[20];
-  cout << "\nPlease give me a new value for " << this->title << " [0,1](defualt:" << this->defaultValue << "): ";
+  cout << "\nPlease give me a new value for " << this->title << " [0,1](default:" << this->defaultValue << "): ";
   cin >> tmpChar;
 
@@ -1350,48 +1258,23 @@
 Slider::~Slider(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initializes a Slider with start and end Values
-   params: see Slider::Slider(char* slidername, int start, int end)
-*/
-void Slider::init(int start, int end)
-{
-  this->isOption = 2;
-
-  static_cast<Option*>(this)->init();
-
-  this->start = start;
-  this->end = end;
-#ifdef HAVE_GTK2
- widget = gtk_hscale_new_with_range(this->start, this->end, 5);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a Slider.
-*/
-void Slider::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Slider: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Slider.\n");
-
-  static_cast<Option*>(this)->destroy();
-
-}
-
-/**
-   \brief Sets a new Title to the Slider
-   \param title The new Name of the slider
-*/
-void Slider::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char[strlen(title)+1];
-  strcpy(this->title, title);
+}
+
+/**
+   \brief Initializes a Slider with start and end Values
+   params: see Slider::Slider(char* slidername, int start, int end)
+*/
+void Slider::init(int start, int end)
+{
+  this->isOption = 2;
+
+  this->start = start;
+  this->end = end;
+#ifdef HAVE_GTK2
+ widget = gtk_hscale_new_with_range(this->start, this->end, 5);
+#endif /* HAVE_GTK2 */
 }
 
@@ -1425,5 +1308,5 @@
 #else /* HAVE_GTK2 */
   char tmpChar[20];
-  cout << "\nPlease give me a new value for " << this->title << " [" <<this->start << "-" << this->end << "](defualt:" << this->defaultValue << "): ";
+  cout << "\nPlease give me a new value for " << this->title << " [" <<this->start << "-" << this->end << "](default:" << this->defaultValue << "): ";
   cin >> tmpChar;
 
@@ -1437,4 +1320,14 @@
 
 /* MENU */
+
+/**
+   \brief constructs a new Menu, without adding any items to it.
+   \param menuName the Name the Menu gets.
+*/
+Menu::Menu(const char* menuName)
+{
+  this->init();
+  this->setTitle(menuName);
+}
 
 /** 
@@ -1448,8 +1341,8 @@
   this->init();
   this->setTitle(menuname);
-    
+  va_list itemlist;                     //!< The list to readin multiple Options.
+
   char *itemName;
 
-#ifdef HAVE_GTK2             /////////////////////// REINPLEMENT
   va_start(itemlist, menuname);
   while(strcmp(itemName = va_arg(itemlist, char*), "lastItem"))
@@ -1458,10 +1351,4 @@
     }
   va_end(itemlist);
-#endif /* HAVE_GTK2 */
-
-#ifdef HAVE_GTK2
-  gtk_option_menu_set_menu(GTK_OPTION_MENU(this->widget), menu);
-  this->connectSignal("changed", this->OptionChange);
-#endif /* HAVE_GTK2 */
 }
 
@@ -1471,28 +1358,4 @@
 Menu::~Menu(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initializes a new Menu with no items
-*/
-void Menu::init(void)
-{
-  this->isOption = 2;
-
-  static_cast<Option*>(this)->init();
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_option_menu_new();
-  this->menu = gtk_menu_new();
-#endif /* HAVE_GTK2 */
-
-}
-
-/**
-   \brief Destroys a Menu.
-*/
-void Menu::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Menu: %s\n", this->title);
@@ -1500,19 +1363,70 @@
     PRINTF(3)("deleting the Menu.\n");
   //! \todo destroy menu
-  
-  static_cast<Option*>(this)->destroy();
-}
-
-
-/**
- * Sets the Database-Name of this Menu
- \param title Database-Name to be set.
-*/
-void Menu::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char[strlen(title)+1];
-  strcpy(this->title, title);
+  this->currItem = this->firstItem;
+  while(this->currItem)
+    {
+      delete []this->currItem->name;
+      /*
+	#ifdef HAVE_GTK2
+	free(this->currItem->item);
+	#endif /* HAVE_GTK2 */
+      MenuItem* tmpItem = this->currItem;
+      this->currItem = this->currItem->next;
+      delete tmpItem;
+    }
+}
+
+/**
+   \brief Initializes a new Menu with no items
+*/
+void Menu::init(void)
+{
+  this->isOption = 2;
+  this->firstItem = NULL;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_option_menu_new();
+  this->menu = gtk_menu_new();
+  gtk_option_menu_set_menu(GTK_OPTION_MENU(this->widget), menu);
+  this->connectSignal("changed", this->OptionChange);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \brief saves the Label of the Menu
+   \returns the name of the selected Menu-Item
+*/
+char* Menu::save(void)
+{
+  MenuItem* tmpItem = this->firstItem;
+  for (int i = 0; i<this->value; i++)
+    tmpItem = tmpItem->next;
+      
+  return tmpItem->name;
+}
+
+/**
+   \brief loads a Menu from of its loadString
+   \param loadString the string from which to load the data from
+*/
+void Menu::load(char* loadString)
+{
+  MenuItem* tmpItem = firstItem;
+  bool foundItem = false;
+  while (tmpItem)
+    {
+      if (!strcmp(loadString, tmpItem->name))
+	{foundItem = true; break;}
+      tmpItem = tmpItem->next;
+    }
+  if (foundItem)
+    this->value = tmpItem->itemNumber;
+  else
+    {
+      this->value = 0;
+      PRINTF(2)("Sorry, but %s has not been found in the Itemlist of %s\n", loadString, this->title);
+    }
+  PRINTF(3)( "Loading %s: setting to %d\n", this->title, this->value); 
+  this->redraw();
 }
 
@@ -1520,13 +1434,27 @@
    \brief appends a new Item to the Menu-List.
    \param itemName the itemName to be appendet.
-
-   \todo make the item-list readable without GTK
 */
 void Menu::addItem(char* itemName)
 {
-#ifdef HAVE_GTK2
-  this->item = gtk_menu_item_new_with_label(itemName);
-  gtk_menu_shell_append(GTK_MENU_SHELL(this->menu), this->item);
-#endif /* HAVE_GTK2 */
+  if (!this->firstItem)
+    {
+      this->firstItem = this->currItem = new MenuItem;
+      this->currItem->itemNumber = 0;
+    }
+  else
+    {
+      int tmpI = this->currItem->itemNumber;
+      this->currItem = this->currItem->next = new MenuItem;
+      this->currItem->itemNumber = tmpI+1;
+    }
+
+  this->currItem->name = new char[strlen(itemName)+1];
+  strcpy(this->currItem->name, itemName);
+
+#ifdef HAVE_GTK2
+  this->currItem->item = gtk_menu_item_new_with_label(itemName);
+  gtk_menu_shell_append(GTK_MENU_SHELL(this->menu), this->currItem->item);
+#endif /* HAVE_GTK2 */
+  this->currItem->next = NULL;
 }
 
@@ -1551,5 +1479,5 @@
 #else /* HAVE_GTK2 */
   char tmpChar[20];
-  cout << "\nPlease give me a new value for " << this->title << "(defualt:" << this->defaultValue << "): ";
+  cout << "\nPlease give me a new value for " << this->title << "(default:" << this->defaultValue << "): ";
   cin >> tmpChar;
   this->value = atoi(tmpChar);
@@ -1578,27 +1506,4 @@
 OptionLabel::~OptionLabel(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief Initializes an OptionLabel
-*/
-void OptionLabel::init(void)
-{
-  this->isOption = 5;
-  static_cast<Option*>(this)->init();
-
-  cValue = NULL;
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_label_new("");
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a OptionLabel.
-*/
-void OptionLabel::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the OptionLabel: %s\n", this->title);
@@ -1607,8 +1512,18 @@
   if (this->cValue)
     delete []this->cValue;
-
-  static_cast<Option*>(this)->destroy();
-}
-
+}
+
+/**
+   \brief Initializes an OptionLabel
+*/
+void OptionLabel::init(void)
+{
+  this->isOption = 5;
+  cValue = NULL;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_label_new("");
+#endif /* HAVE_GTK2 */
+}
 
 /**
@@ -1628,17 +1543,4 @@
 
 /**
-   \brief Sets a ned Title to the OptionLabel.
-   \param title The now title of the OptionLabel.
-*/
-void OptionLabel::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char [strlen(title)+1];
-  strcpy(this->title, title);
-  this->redraw();
-}
-
-/**
    \brief Redraws an OptionLabel(not implemented yet, but it works).
 */
@@ -1666,4 +1568,23 @@
 
 /**
+   \brief creates the Optionlabel save-string
+   \returns the String to save.
+*/
+char* OptionLabel::save(void)
+{
+  return cValue;
+}
+
+/**
+   \brief loads an Option from of its loadString
+   \param loadString the string from which to load the data from
+*/
+void OptionLabel::load(char* loadString)
+{
+  PRINTF(3)( "Loading %s: setting to %s\n", this->title, loadString); 
+  this->setValue(loadString);
+}
+
+/**
    \brief Creates a new default Label with no Text.
    You migth consider adding Label::setTitle with this.
@@ -1689,33 +1610,21 @@
 Label::~Label(void)
 {
-  this->destroy();
-}
-
-/**
-   \brief initializes a new Label
-*/
-void Label::init(void)
-{
-  this->isOption = 0;
-
-  static_cast<Widget*>(this)->init();
-
-#ifdef HAVE_GTK2
-  this->widget = gtk_label_new("");
-  gtk_label_set_line_wrap(GTK_LABEL(this->widget), TRUE);
-#endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a Label.
-*/
-void Label::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Label: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Label.\n");
-
-  static_cast<Widget*>(this)->destroy();
+}
+
+/**
+   \brief initializes a new Label
+*/
+void Label::init(void)
+{
+  this->isOption = 0;
+
+#ifdef HAVE_GTK2
+  this->widget = gtk_label_new("");
+  gtk_label_set_line_wrap(GTK_LABEL(this->widget), TRUE);
+#endif /* HAVE_GTK2 */
 }
 
@@ -1813,5 +1722,8 @@
 ProgressBar::~ProgressBar(void)
 {
-  this->destroy();
+  if (this->title)
+    PRINTF(3)("deleting the ProgressBar: %s\n", this->title);
+  else 
+    PRINTF(3)("deleting the ProgressBar.\n");
 }
 
@@ -1825,34 +1737,8 @@
   this->totalSize = 0.0;
 
-  static_cast<Widget*>(this)->init();
 #ifdef HAVE_GTK2
   this->adjustment =(GtkAdjustment*)gtk_adjustment_new(0, 0, 100, 0, 0, 0);
   this->widget = gtk_progress_bar_new_with_adjustment(this->adjustment);
 #endif /* HAVE_GTK2 */
-}
-
-/**
-   \brief Destroys a ProgressBar.
-*/
-void ProgressBar::destroy(void)
-{ 
-  if (this->title)
-    PRINTF(3)("deleting the ProgressBar: %s\n", this->title);
-  else 
-    PRINTF(3)("deleting the ProgressBar.\n");
-
-  static_cast<Widget*>(this)->destroy();
-}
-
-/**
-   \brief Sets a ned Title to the ProgressBar.
-   \param title The now title of the ProgressBar.
-*/
-void ProgressBar::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char [strlen(title)+1];
-  strcpy(this->title, title);
 }
 
@@ -1913,39 +1799,15 @@
 Image::~Image(void)
 {
-  this->destroy();
-}
-
-/** 
-    \brief Initializes a new Image
-*/
-void Image::init(void)
-{
-  isOption = 0;
-
-  static_cast<Widget*>(this)->init();
-}
-
-/**
-   \brief Destroys a Image.
-*/
-void Image::destroy(void)
-{ 
   if (this->title)
     PRINTF(3)("deleting the Image: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Image.\n");
-
-  static_cast<Widget*>(this)->destroy();
-}
-
-/**
-   \brief Sets a ned Title to the Image.
-   \param title The now title of the OptionLabel.
-*/
-void Image::setTitle(char* title)
-{
-  if (this->title)
-    delete []this->title;
-  this->title = new char [strlen(title)+1];
-  strcpy(this->title, title);
-}
+}
+
+/** 
+    \brief Initializes a new Image
+*/
+void Image::init(void)
+{
+  isOption = 0;
+}
